
#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

vector<vector<int>> gr;
vector<int> used;
vector<int> pred;
int w = 1;
int q;

void dfs(int a) {
	used[a] = 1;
	for (int i = 0;i < gr[a].size();i++) {
		if (used[gr[a][i]] == 1) {
			q = a;
		}
		if (used[gr[a][i]] == 0) {
			w++;
			pred[gr[a][i]] = a;
			dfs(gr[a][i]);
		}
	}
}

int main() {
	int n, ans = 0;
	cin >> n;
	vector<int> room1;
	vector<int> room2;
	gr.resize(n);
	used.resize(n);
	pred.resize(n);
	for (int i = 0;i < n;i++) {
		int v;
		cin >> v;
		gr[i].push_back(v - 1);
	}
	for (int i = 0;i < n;i++) {
		if (used[i] == 0) {
			w = 1;
			pred[i] = -1;
			dfs(i);
			if (w % 2 == 0) {
				while (q != -1) {
					if (w % 2 == 0) {
						room2.push_back(q);
					}
					else {
						room1.push_back(q);
					}
					w--;
					q = pred[q];
				}
			}

			else {
				ans++;
				q = pred[q];
				while (q != -1) {
					if (w % 2 == 0) {
						room2.push_back(q);
					}
					else {
						room1.push_back(q);
					}
					w--;
					q = pred[q];
				}
			}
		}
	}
	cout << ans << '\n';
	for (int i = 0;i < room1.size();i++) {
		cout << room1[i] + 1 << " ";
	}
	cout << '\n';
	for (int i = 0;i < room2.size();i++) {
		cout << room2[i] + 1 << " ";
	}
}

