#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

vector<int> used;
vector<int> pred;


int main() {
    int n, ans = 0;
    cin >> n;
    vector<int> room1;
    vector<int> room0;
    used.resize(n, -1);
    pred.resize(n);
    for (int i = 0;i < n;i++) {
        int v;
        cin >> v;
        pred[v - 1] = i;
    }
    int w = 0;
    for (int i = 0;i < n;i++) {
        if (used[i] == -1) {
            used[i] = 1;
            w = 1;
            room1.push_back(i);
            int q = i;
            while (used[pred[q]] == -1) {
                q = pred[q];
                w = (w + 1) % 2;
                used[q] = w;
                if (used[q] == used[pred[q]]) {
                    ans++;
                }
                else {
                    if (used[q] == 0) {
                        room0.push_back(q);
                    }
                    else {
                        room1.push_back(q);
                    }
                }
            }
        }
    }
    cout << ans << '\n';
    for (int i = 0;i < room1.size();i++) {
        cout << room1[i] + 1 << " ";
    }
    cout << '\n';
    for (int i = 0;i < room0.size();i++) {
        cout << room0[i] + 1 << " ";
    }
}