#include <iostream>
#include <vector>
#include <queue>

using namespace std;

vector<vector<pair<int,int>>>gr1;
vector<int> dist;
long long  n1, n2, n3, n4;
void bfs(long long  a) {
    dist[a] = 0;
    queue<int> q;
    q.push(a);
    while (q.size() > 0) {
        long long  v = q.front();
        q.pop();
        for (long long  i = 0;i < gr1[v].size();i++) {
            if (dist[gr1[v][i].first] > dist[v] + 1 && gr1[v][i].second != n1 && gr1[v][i].second != n2 && gr1[v][i].second != n3 && gr1[v][i].second != n4) {
                dist[gr1[v][i].first] = dist[v] + 1;
                q.push(gr1[v][i].first);
            }
        }
    }
}

int main() {
    long long  n, m;
    cin >> n >> m;
    gr1.resize(n * m);
    dist.resize(n * m, long long(1e9) );
    vector<vector<char>> z(n, vector<char>(m - 1));
    vector<vector<char>> k(n - 1, vector<char>(m));
    for (long long  i = 0;i < n;i++) {
        for (long long  j = 0;j < m - 1;j++) {
            cin >> z[i][j];
            if (z[i][j] == 'B') {
                gr1[m * i + j + 1].push_back({ m * i + j,1 });
                gr1[m * i + j].push_back({ m * i + j + 1 ,1 });
            }
            if (z[i][j] == 'R') {
                gr1[m * i + j + 1].push_back({ m * i + j,2 });
                gr1[m * i + j].push_back({ m * i + j + 1 ,2 });
            }
            if (z[i][j] == 'G') {
                gr1[m * i + j + 1].push_back({ m * i + j,3 });
                gr1[m * i + j].push_back({ m * i + j + 1 ,3 });
            }
            if (z[i][j] == 'O') {
                gr1[m * i + j + 1].push_back({ m * i + j,4 });
                gr1[m * i + j].push_back({ m * i + j + 1 ,4 });
            }

        }
    }
    for (long long  i = 0;i < n - 1;i++) {
        for (long long  j = 0;j < m;j++) {
            cin >> k[i][j];
            if (k[i][j] == 'B') {
                gr1[m * (i + 1) + j].push_back({ m * i + j,1 });
                gr1[m * i + j].push_back({ m * (i + 1) + j ,1 });
            }
            if (k[i][j] == 'R') {
                gr1[m * (i + 1) + j].push_back({ m * i + j,2 });
                gr1[m * i + j].push_back({ m * (i + 1) + j ,2 });
            }
            if (k[i][j] == 'G') {
                gr1[m * (i + 1) + j].push_back({ m * i + j,3 });
                gr1[m * i + j].push_back({ m * (i + 1) + j ,3 });
            }
            if (k[i][j] == 'O') {
                gr1[m * (i + 1) + j].push_back({ m * i + j,4 });
                gr1[m * i + j].push_back({ m * (i + 1) + j ,4 });
            }
        }
    }
    long long  q;
    cin >> q;
    while (q--) {
        long long  a, b, c, d;
        cin >> a >> b >> c >> d;
        n1 = 0;
        n2 = 2;
        n3 = 3;
        n4 = 4;
        bfs(m * (a - 1) + b - 1);
        if (dist[m * (c - 1) + d - 1] != long long(1e9) ) {
            cout << 1 << '\n';
        }
        else {
            n1 = 1;
            n2 = 0;
            n3 = 3;
            n4 = 4;
            dist.clear();
            dist.resize(n * m, long long(1e9) );
            bfs(m * (a - 1) + b - 1);
            if (dist[m * (c - 1) + d - 1] != long long(1e9) ) {
                cout << 1 << '\n';
            }
            else {
                n1 = 1;
                n2 = 2;
                n3 = 0;
                n4 = 4;
                dist.clear();
                dist.resize(n * m, long long(1e9) );
                bfs(m * (a - 1) + b - 1);
                if (dist[m * (c - 1) + d - 1] != long long(1e9) ) {
                    cout << 1 << '\n';
                }
                else {
                    n1 = 1;
                    n2 = 2;
                    n3 = 3;
                    n4 = 0;
                    dist.clear();
                    dist.resize(n * m, long long(1e9) );
                    bfs(m * (a - 1) + b - 1);
                    if (dist[m * (c - 1) + d - 1] != long long(1e9) ) {
                        cout << 1 << '\n';
                    }
                    else {
                        n1 = 1;
                        n2 = 2;
                        n3 = 0;
                        n4 = 0;
                        dist.clear();
                        dist.resize(n * m, long long(1e9) );
                        bfs(m * (a - 1) + b - 1);
                        if (dist[m * (c - 1) + d - 1] != long long(1e9) ) {
                            cout << 2 << '\n';
                        }
                        else {
                            n1 = 1;
                            n2 = 0;
                            n3 = 3;
                            n4 = 0;
                            dist.clear();
                            dist.resize(n * m, long long(1e9) );
                            bfs(m * (a - 1) + b - 1);
                            if (dist[m * (c - 1) + d - 1] != long long(1e9) ) {
                                cout << 2 << '\n';
                            }
                            else {
                                n1 = 1;
                                n2 = 0;
                                n3 = 0;
                                n4 = 4;
                                dist.clear();
                                dist.resize(n * m, long long(1e9) );
                                bfs(m * (a - 1) + b - 1);
                                if (dist[m * (c - 1) + d - 1] != long long(1e9) ) {
                                    cout << 2 << '\n';
                                }
                                else {
                                    n1 = 0;
                                    n2 = 2;
                                    n3 = 3;
                                    n4 = 0;
                                    dist.clear();
                                    dist.resize(n * m, long long(1e9) );
                                    bfs(m * (a - 1) + b - 1);
                                    if (dist[m * (c - 1) + d - 1] != long long(1e9) ) {
                                        cout << 2 << '\n';
                                    }
                                    else {
                                        n1 = 0;
                                        n2 = 2;
                                        n3 = 0;
                                        n4 = 4;
                                        dist.clear();
                                        dist.resize(n * m, long long(1e9) );
                                        bfs(m * (a - 1) + b - 1);
                                        if (dist[m * (c - 1) + d - 1] != long long(1e9) ) {
                                            cout << 2 << '\n';
                                        }
                                        else {
                                            n1 = 0;
                                            n2 = 0;
                                            n3 = 3;
                                            n4 = 4;
                                            dist.clear();
                                            dist.resize(n * m, long long(1e9) );
                                            bfs(m * (a - 1) + b - 1);
                                            if (dist[m * (c - 1) + d - 1] != long long(1e9) ) {
                                                cout << 2 << '\n';
                                            }
                                            else {
                                                n1 = 0;
                                                n2 = 0;
                                                n3 = 0;
                                                n4 = 4;
                                                dist.clear();
                                                dist.resize(n * m, long long(1e9) );
                                                bfs(m * (a - 1) + b - 1);
                                                if (dist[m * (c - 1) + d - 1] != long long(1e9) ) {
                                                    cout << 3 << '\n';
                                                }
                                                else {
                                                    n1 = 0;
                                                    n2 = 0;
                                                    n3 = 3;
                                                    n4 = 0;
                                                    dist.clear();
                                                    dist.resize(n * m, long long(1e9) );
                                                    bfs(m * (a - 1) + b - 1);
                                                    if (dist[m * (c - 1) + d - 1] != long long(1e9) ) {
                                                        cout << 3 << '\n';
                                                    }
                                                    else {
                                                        n1 = 0;
                                                        n2 = 2;
                                                        n3 = 0;
                                                        n4 = 0;
                                                        dist.clear();
                                                        dist.resize(n * m, long long(1e9) );
                                                        bfs(m * (a - 1) + b - 1);
                                                        if (dist[m * (c - 1) + d - 1] != long long(1e9) ) {
                                                            cout << 3 << '\n';
                                                        }
                                                        else {
                                                            n1 = 1;
                                                            n2 = 0;
                                                            n3 = 0;
                                                            n4 = 0;
                                                            dist.clear();
                                                            dist.resize(n * m, long long(1e9) );
                                                            bfs(m * (a - 1) + b - 1);
                                                            if (dist[m * (c - 1) + d - 1] != long long(1e9) ) {
                                                                cout << 3 << '\n';
                                                            }
                                                            else {
                                                                cout << 4 << '\n';
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
        dist.clear();
        dist.resize(n* m, long long(1e9) );
    }
}